// Copyright (c) 2016 Jakub Wasilewski
// aka krajzeg http://www.lexaloffle.com/bbs/?tid=4100
// Github: https://github.com/krajzeg/pico8gamepad/
// multiplayer & additional buttons mod by ultrabrite

// Array through which we'll communicate with PICO-8.
var pico8_buttons = [0];
// Start polling gamepads.
requestAnimationFrame(updateGamepads);

// handle gamepad redundancy
// useful if you have some unpractical gear
// (driving wheel or something) that sits at slot 0.
var actual_players=2 // 3rd controller will act as 1st

// Workhorse function, updates pico8_buttons once per frame.
function updateGamepads() {
  
  var gamepads = navigator.getGamepads ? navigator.getGamepads() : [];
  // Gather input from all known gamepads.
  var nbg = (gamepads.length>8) ? 8 : gamepads.length
  
  for (var i = 0; i < nbg; i++) pico8_buttons[i]=0

  for (var i = 0; i < nbg; i++) {
  	var gp = gamepads[i];
  	if (!gp || !gp.connected) continue;
	
    var bitmask = 0;
    // directions (from axes or d-pad "buttons")
  	bitmask |= (axis(gp,0)<-0.5 || axis(gp,2)<-0.5 || btn(gp,14)) ? 1 : 0;
  	bitmask |= (axis(gp,0)> 0.5 || axis(gp,2)> 0.5 || btn(gp,15)) ? 2 : 0;
  	bitmask |= (axis(gp,1)<-0.5 || axis(gp,3)<-0.5 || btn(gp,12)) ? 4 : 0;
  	bitmask |= (axis(gp,1)> 0.5 || axis(gp,3)> 0.5 || btn(gp,13)) ? 8 : 0;
    // buttons (mapped twice for user convenience)
  	bitmask |= (btn(gp,0) || btn(gp,2) || btn(gp,4) || btn(gp,7) || btn(gp,10)) ? 16 : 0;
  	bitmask |= (btn(gp,1) || btn(gp,3) || btn(gp,5) || btn(gp,6) || btn(gp,11)) ? 32 : 0;
	bitmask |= (btn(gp,8) || btn(gp,9)) ? 64 : 0;
	// update actual array
	pico8_buttons[i%actual_players] |= bitmask
  }

  // restart next frame.
	requestAnimationFrame(updateGamepads);
}

// Helpers for accessing gamepad
function axis(gp,n) { return gp.axes[n] || 0.0; }
function btn(gp,b) { return gp.buttons[b] ? gp.buttons[b].pressed : false; }
